with GNATCOM.IInterface;

with GNATCOM.Errors;

package body MSHTML.IHTMLEmbedElement2_Interface is

   procedure Initialize (This : in out IHTMLEmbedElement2_Type) is
   begin
      Set_IID (This, IID_IHTMLEmbedElement2);
   end Initialize;

   function Pointer (This : IHTMLEmbedElement2_Type)
     return Pointer_To_IHTMLEmbedElement2
   is
   begin
      return To_Pointer_To_IHTMLEmbedElement2 (Address (This));
   end Pointer;

   procedure Attach (This    : in out IHTMLEmbedElement2_Type;
                     Pointer : in     Pointer_To_IHTMLEmbedElement2)
   is
   begin
      Attach (This, GNATCOM.IInterface.To_Pointer_To_IUnknown
              (Pointer.all'Address));
   end Attach;

   procedure Put_src
     (This : IHTMLEmbedElement2_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_src
         (Pointer (This),
          p));

      if Free then
               GNATCOM.IInterface.Free (p);
      
      end if;

   end Put_src;

   function Get_src
     (This : IHTMLEmbedElement2_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_src
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_src;

   function Get_pluginspage
     (This : IHTMLEmbedElement2_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_pluginspage
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_pluginspage;

end MSHTML.IHTMLEmbedElement2_Interface;

